#include "interfIOMenu.h"
#include "interfMainPanel.h"

interfIOMenu::interfIOMenu(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: interfMenuBar(parent, sizex, sizey)
{
	this->datadir = datdir;
//	eventHandler = evtHandler;
	initButtons(this);
}

void interfIOMenu::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/Open.png");
	nom.push_back("Open a previously saved file that contains contours information  ctrl + o");
	funct.push_back((wxObjectEventFunction) &interfIOMenu:: onLoad);

	path.push_back(datadir + "/Save.png");
	nom.push_back("Save all contours created ctrl + s");
	funct.push_back((wxObjectEventFunction) &interfIOMenu:: onSave);

	this->addButtons(path, nom);
	this->setVectorFunction(funct);

	//this->setButtonName(0, 'O');
	//this->setButtonName(1, ');

	this->connectEvents(evtHandler);

}
void interfIOMenu::onLoad(wxCommandEvent& event){
	interfMainPanel::getInstance()->onLoad();
}
void interfIOMenu::onSave(wxCommandEvent& event){
	interfMainPanel::getInstance()->onSave();
}
interfIOMenu::~interfIOMenu()
{
}

