#include "interfNewContourMenu.h"


interfNewContourMenu::interfNewContourMenu(wxWindow * parent, int sizex, int sizey, wxEvtHandler* evtHandler, std::string datdir)
	: interfMenuBar(parent, sizex, sizey)
{
	this->datadir = datdir;
	//eventHandler = (wxContourEventHandler*)evtHandler;

	panBull = NULL;
	created = false;

	initButtons(this);	
}

void interfNewContourMenu::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;
	std::vector<wxEvtHandler*> hand;
	
	path.push_back(datadir + "/Spline.png");
	nom.push_back("Create a contour using splines");	
	funct.push_back((wxObjectEventFunction)&interfNewContourMenu::onCreateContourSpline);
	hand.push_back(evtHandler);

	path.push_back(datadir+"/Rectangle.png");
	nom.push_back("Create a contour using the basic shape of a rectangle");
	funct.push_back((wxObjectEventFunction)&interfNewContourMenu::onCreateContourRectangle);
	hand.push_back(evtHandler);

	path.push_back(datadir + "/Circle.png");
	nom.push_back("Create a contour using the basic shape of a Circle");
	funct.push_back((wxObjectEventFunction)&interfNewContourMenu::onCreateContourCircle);
	hand.push_back(evtHandler);

	path.push_back(datadir + "/bullseye.png");
	nom.push_back("Create a contour using the bulls eye");
	funct.push_back((wxObjectEventFunction) &interfNewContourMenu::onCreateContourBullseye);
	hand.push_back(this);

	path.push_back(datadir + "/Line.png");
	nom.push_back("Create a Line");
	funct.push_back((wxObjectEventFunction) &interfNewContourMenu::onCreateContourLine);
	hand.push_back(this);

	// RaC 09-09 ---------------------
	path.push_back(datadir + "/Points.png");
	nom.push_back("Create Points");
	funct.push_back((wxObjectEventFunction) &interfNewContourMenu::onCreateContourPoints);
	hand.push_back(this);
	// RaC 09-09 ---------------------	

	// RaC 10-09 ---------------------
	path.push_back(datadir + "/Polygon.png");
	nom.push_back("Create Polygon");
	funct.push_back((wxObjectEventFunction) &interfNewContourMenu::onCreateContourPolygon);
	hand.push_back(this);
	// RaC 10-09 ---------------------	

    this->addButtons(path, nom);

	this->setVectorFunction(funct);	
	this->setEventHandlers(hand);	
	this->connectEvents();

}



interfNewContourMenu::~interfNewContourMenu()
{
}

void interfNewContourMenu::onCreateContourBullseye(wxCommandEvent& event){


	if(!created){

		panBull = new PanelBullEyeOptions(interfMainPanel::getInstance()->getInfoPanel(), 
								wxSize(100,200));
		created = true;
	}
	interfMainPanel::getInstance()->onCreateContoursBullEye(panBull);
	//eventHandler->createContourBullsEye(panBull);
	interfMainPanel::getInstance()->showPanel(panBull);

}

void interfNewContourMenu::onCreateContourSpline( wxCommandEvent& event ){
	interfMainPanel::getInstance()->onCreateContourSpline();
}
void interfNewContourMenu::onCreateContourRectangle( wxCommandEvent& event ){
	interfMainPanel::getInstance()->onCreateContourRectangle();
}
void interfNewContourMenu::onCreateContourCircle( wxCommandEvent& event ){
	interfMainPanel::getInstance()->onCreateContourCircle();
}
void interfNewContourMenu::onCreateContourLine( wxCommandEvent& event ){
	interfMainPanel::getInstance()->onCreateContourLine();
}

// RaC 09-09 ---------------------
void interfNewContourMenu::onCreateContourPoints( wxCommandEvent& event ){
	interfMainPanel::getInstance()->onCreateContourPoints();
}
// RaC 09-09 ---------------------

// RaC 10-09 ---------------------
void interfNewContourMenu::onCreateContourPolygon( wxCommandEvent& event ){
	interfMainPanel::getInstance()->onCreateContourPolygon();
}
// RaC 10-09 ---------------------

