#ifndef __ConceptDataWrap_h_INCLUDED_H__
#define __ConceptDataWrap_h_INCLUDED_H__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream> 
#include <string>

/** file ConceptDataWrap.h */


//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------
class ConceptDataWrap {

	public:

	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

	ConceptDataWrap(std::string theName = "");

	~ConceptDataWrap();

	//------------------------------------------------------------------------------------------------------------
	//  Attributes getters and setters
	//------------------------------------------------------------------------------------------------------------
	
	/**
	* Sets the data concept values and name
	* @param theName The name of the concept 
	* @param minRepresent The minRepresent value of the concept 
	* @param maxRepresent The maxRepresent value of the concept 
	* @param minShowed The minShowed value of the concept 
	* @param maxShowed The maxShowed value of the concept 
	* @param actualShow The actualShow value of the concept 
	*/
	void fillData( std::string theName, int minRepresent, int maxRepresent, int minShowed, int maxShowed, int actualShow );

	std::string getName();

	int getMinShowedValue();

	int getMaxShowedValue();

	void setMinValue(int theMin);

	int getMinValue();

	void setMaxValue(int theMax);

	int getMaxValue();

	void setActualValue(int theActual);

	int getActualValue();

	bool isEmpty( );

	//------------------------------------------------------------------------------------------------------------
	//  Other functional methods
	//------------------------------------------------------------------------------------------------------------

private:
	//------------------------------------------------------------------------------------------------------------
	//  Private methods
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	// Creational and initialization methods
	//------------------------------------------------------------------------------------------------------------

		
	//------------------------------------------------------------------------------------------------------------
	// Attributtes
	//------------------------------------------------------------------------------------------------------------
	int _minValue;

	int _maxValue;

	int _minShow;

	int _maxShow;

	int _actual;

	std::string _name;


};
#endif // __ConceptDataWrap_HEADER_FILE__
 
 
